Subject: bug#11735: 24.1.50; "Warning: Unknown defun property ... in ..."

From: "Drew Adams" <[email-masked]>
Date: Mon, 18 Jun 2012 14:11:35 -0700

> > > Warning: Unknown defun property fixnum in foo
> > > Warning: Unknown defun property simple-string in foo
> >  
> > > Is this a bug?
> >  
> > It's a name-clash between Elisp's `declare' and CL's 
> > `declare', which results in warnings, which AFAIK are harmless.
> 
> Yes, well it would be clearer for us to say something about 
> _declare_ here, not just something about a "defun property".
> 
> Bonus points for saying something to make it clear to users 
> (of cl.el) that these particular Common Lisp `declare' settings are not 
> supported by cl.el.
> 
> (Warnings are not necessarily harmless, BTW, mais passons...)
> 
> Anyway, feel free to close the bug.  I mainly wanted to raise 
> the question, not being sure this was the message you intended.

Actually, no; I'm being too lenient about this.

This should _not_ be a runtime message that _users_ see, IMO.  Byte-compiler
"warnings" are one thing (they can be annoying enough occasionally).  This,
however, is downright obnoxious.

I'm seeing this each time I start Emacs, just because I load a library
(`el-swank-fuzzy') that someone converted from SLIME code.

If Emacs doesn't know how to handle such things then it should wisely apply the
maxim, "Better to keep your mouth shut and be thought a fool than to open it and
remove all doubt."  IOW, do not advertise Emacs ignorance at runtime, just pass
over it in respectful silence.

Byte compilation is a different story.  Yes, we should let someone who is
byte-compiling know about such things.  But not users who just load (and maybe
never invoke anything in) some library.

Can we please put a muzzle on this?  Thx.